/* colors.c */
/* Jed Margolin 1998 */
/* Put out some color bars */

/* Remember to add c:\tc\bgi\egavga.obj to the link string */
/* Remember to add c:\tc\bgi\litt.obj to the link string */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include <graphics.h>
#include <math.h>
#include "colors.h"

#define SCOLOR 15
#define FALSE (0) 
#define	TRUE  (1) 
#define NUMLINES 25
#define NUMCOLS 80
#define RETURN 13  
#define UPARROW 72 
#define DOWNARROW 80
#define ESC 27
#define FF 13
#define CR 10
#define LEFTARROW 75 
#define RIGHTARROW 77
#define CTL_LEFTARROW 115
#define CTL_RIGHTARROW 116

void cbarpgm(void),cbarpgm2(void);
void dial_solidbox(int,int,int,int,int);
void border(void),box(int,int,int,int,int);
void dial_lines(int,int,int,int),do_pointer(int,int);
void draw_table(void),draw_bars(void),draw_table2(void);
/* ======================================================================== */
/* ======================================================================== */
void cbarpgm()
{
   int driver, mode;
/*------------------------------------------------------------------------- */
   clrscr();
/*------------------------------------------------------------------------- */
/* Initialize Graphics */
   driver = VGA;
   mode = VGAHI;
   registerbgidriver(EGAVGA_driver);
   registerbgifont(small_font);

   initgraph(&driver, &mode, "");

   settextstyle(SMALL_FONT,HORIZ_DIR,0);
   setusercharsize(3,3,3,3);
/* ------------------------------------------------------------------------ */
//   setcolor(WHITE);
//   border();

   draw_table2();

   getch();
/* ---------------------------------------------------------------------- */
   restorecrtmode();
//   return();
}
/* ====================================================================== */
/* ======================================================================== */
void cbarpgm2()
{
   int driver, mode;
/*------------------------------------------------------------------------- */
   clrscr();
/*------------------------------------------------------------------------- */
/* Initialize Graphics */
   driver = VGA;
   mode = VGAHI;
   registerbgidriver(EGAVGA_driver);
   registerbgifont(small_font);

   initgraph(&driver, &mode, "");

   settextstyle(SMALL_FONT,HORIZ_DIR,0);
   setusercharsize(3,3,3,3);
/* ------------------------------------------------------------------------ */
   setcolor(WHITE);
   border();

   draw_bars();

   draw_table();

   getch();
/* ---------------------------------------------------------------------- */
   restorecrtmode();
//   return();
}
/* ====================================================================== */
/* ====================================================================== */
/*
Draw a border around the screen for perspective */
void border()
{
   line(0,0,639,0);
   line(0,0,0,479);
   line(0,479,639,479);
   line(639,0,639,479);
}
/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */
/* Draw a box given the coordinates of its two corners */
void dialbox(int startx, int starty, int width, int height, int color)
{

   setcolor(color);

   line(startx, starty, startx, starty+height);
   line(startx, starty, startx+width, starty);
   line(startx+width, starty, startx+width, starty+height);
   line(startx+width, starty+height, startx, starty+height);
}
/* ------------------------------------------------------------------------ */
/* Draw a solid box given the coordinates of its two corners */
void dial_solidbox(int startx, int starty, int width, int height, int color)
{
   int box[10];

   box[0]= startx;
   box[1] = starty;

   box[2] = startx+width;
   box[3] = starty;

   box[4] = startx+width;
   box[5] = starty+height;

   box[6] = startx;
   box[7] = starty+height;

   box[8]= startx;
   box[9] = starty;

   setcolor(color);
   setfillstyle(SOLID_FILL,color);
   fillpoly(5,box);
}
/* ------------------------------------------------------------------------ */
/* Draw a box given the coordinates of its two corners */
void box(int startx, int starty, int endx, int endy, int color)
{
   setcolor(color);

   line(startx, starty, startx, endy);
   line(startx, starty, endx, starty);
   line(endx, starty, endx, endy);
   line(endx, endy, startx, endy);
}
/* ======================================================================== */
void draw_bars()
{
    int n;
    int startx,starty,width,height,color,msgx,msgy;

    startx = 0000;
    starty = 0;
    width = 50;
    height = 320;

    for(n = 0; n<15; n++)
    {
       // color bars
       color = cbars[n].color;
       dial_solidbox(startx,starty,width,height,color);

       // label
//       setcolor(cbars[n].color);
       setcolor(WHITE);
       msgx = startx + 5;
       msgy = starty+height+20;

       outtextxy(msgx,msgy,cbars[n].msg);

       startx = startx + 43;
    }
}
/* ------------------------------------------------------------------------ */
void draw_table()
{
    int n;
    int startx,starty,width,height,color,msgx,msgy;

    for(n = 0; n<3; n++)
    {
       // color bars
       startx = mbars[n].startx;
       starty = mbars[n].starty;
       width  = mbars[n].width;
       height = mbars[n].height;
       color  = mbars[n].color;
       dial_solidbox(startx,starty,width,height,color);

       // label
//       setcolor(mbars[n].color);
       setcolor(WHITE);
       msgx = startx + 55;
       msgy = starty+height+10;

       outtextxy(msgx,msgy,mbars[n].msg);

    }
}
/* ------------------------------------------------------------------------ */
void draw_table2()
{
    int n;
    int startx,starty,width,height,color;

    for(n = 0; n<18; n++)
    {
       // color bars
       startx = mbars2[n].startx;
       starty = mbars2[n].starty;
       width  = mbars2[n].width;
       height = mbars2[n].height;
       color  = mbars2[n].color;
       dial_solidbox(startx,starty,width,height,color);
    }
}
/* ------------------------------------------------------------------------ */
